using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using SMD2XX;
using SelectDevice;

namespace Segment_Test
{

    public partial class Form1 : Form
    {

        #region intialization
        FT_STATUS ftStatus = 0;
        private UInt32 ftHandle = 0;

        SM_D2XX SM = new SM_D2XX();

        Select_Device dev = new Select_Device();

        private byte Output = 0;
        public Form1()
        {
            InitializeComponent();
        }
        #endregion

        #region Segment Buttons
        private void buttona_Click(object sender, EventArgs e)
        {
            if (buttona.BackColor == Color.LightGray)
            {
                buttona.BackColor = Color.Red;
                Output += 0x01;
            }
            else
            {
                buttona.BackColor = Color.LightGray;
                if (Output >= 0x01) Output -= 0x01;
            }

            bitBangOutD(Output);
        }

        private void buttonb_Click(object sender, EventArgs e)
        {
            if (buttonb.BackColor == Color.LightGray)
            {
                buttonb.BackColor = Color.Red;
                Output += 0x02;
            }
            else
            {
                buttonb.BackColor = Color.LightGray;
                if (Output >= 0x02) Output -= 0x02;
            }

            bitBangOutD(Output);
        }

        private void buttonc_Click(object sender, EventArgs e)
        {
            if (buttonc.BackColor == Color.LightGray)
            {
                buttonc.BackColor = Color.Red;
                Output += 0x04;
            }
            else
            {
                buttonc.BackColor = Color.LightGray;
                if (Output >= 0x04) Output -= 0x04;
            }

            bitBangOutD(Output);
        }

        private void buttond_Click(object sender, EventArgs e)
        {
            if (buttond.BackColor == Color.LightGray)
            {
                buttond.BackColor = Color.Red;
                Output += 0x08;
            }
            else
            {
                buttond.BackColor = Color.LightGray;
                if (Output >= 0x08) Output -= 0x08;
            }

            bitBangOutD(Output);
        }

        private void buttone_Click(object sender, EventArgs e)
        {
            if (buttone.BackColor == Color.LightGray)
            {
                buttone.BackColor = Color.Red;
                Output += 0x10;
            }
            else
            {
                buttone.BackColor = Color.LightGray;
                if (Output >= 0x10) Output -= 0x10;
            }

            bitBangOutD(Output);
        }

        private void buttonf_Click(object sender, EventArgs e)
        {
            if (buttonf.BackColor == Color.LightGray)
            {
                buttonf.BackColor = Color.Red;
                Output += 0x20;
            }
            else
            {
                buttonf.BackColor = Color.LightGray;
                if (Output >= 0x20) Output -= 0x20;
            }

            bitBangOutD(Output);
        }

        private void buttong_Click(object sender, EventArgs e)
        {
            if (buttong.BackColor == Color.LightGray)
            {
                buttong.BackColor = Color.Red;
                Output += 0x40;
            }
            else
            {
                buttong.BackColor = Color.LightGray;
                if (Output >= 0x40) Output -= 0x40;
            }

            bitBangOutD(Output);
        }

        private void buttondp_Click(object sender, EventArgs e)
        {
            if (buttondp.BackColor == Color.LightGray)
            {
                buttondp.BackColor = Color.Red;
                Output += 0x80;
            }
            else
            {
                buttondp.BackColor = Color.LightGray;
                if (Output >= 0x80) Output -= 0x80;
            }

            bitBangOutD(Output);
        }
        #endregion

        #region Select and Open a Device

        private void selectDeviceToolStripMenuItem_Click_1(object sender, EventArgs e)
        {
            dev.ShowDialog();

            switch (dev.OpenBy)
            {
                case (uint)OPENBY.SERIAL_NUMBER: // use OpenEX
                    openBySerialNumber(dev.SerialNumber);
                    break;
                case (uint)OPENBY.DESCRIPTION: // use OpenEX
                    openByDescription(dev.Description);
                    break;
                case (uint)OPENBY.LOCATIONID: // use OpenEX
                    openByLocationID(dev.LocID);
                    break;
                default:
                    MessageBox.Show("ERROR - OpenBy = " + dev.OpenBy.ToString());
                    break;
            }
        }

        // open by serial number
        private void openBySerialNumber(string SN)
        {
            ftStatus = SM.openSerialNumber(SN, ref ftHandle);
            if (ftStatus != FT_STATUS.FT_OK)
            {
                MessageBox.Show("Error: buttonGet_Click failed to open device");
            }
        }

        // open by description
        private void openByDescription(string description)
        {
            ftStatus = SM.openDescription(description, ref ftHandle);
            if (ftStatus != FT_STATUS.FT_OK)
            {
                MessageBox.Show("Error: buttonGet_Click failed to open port");
            }
        }

        // open by location
        private void openByLocationID(UInt32 locID)
        {
            ftStatus = SM.openLocationID(locID, ref ftHandle);
            if (ftStatus != FT_STATUS.FT_OK)
            {
                MessageBox.Show("Error: buttonGet_Click failed to open port");
            }
        }

        // Assumes device is open
        private void closeDevice()
        {
            SM.closeDevice(ftHandle);
        }

        #endregion

        #region Bit-bang Output

        private void bitBangOutD(byte Out)
        {
            SM.bitBang_SetBitMode(ftHandle, Out, 0x01);
        }

        #endregion

        byte[] font = new byte[37] {0x77, 0x7C, 0x39, 0x5E, 0x79, 0x71,
                                    0x6F, 0x76, 0x30, 0x1E, 0x70, 0x38,
                                    0x15, 0x54, 0x3F, 0x73, 0x67, 0x50, 
                                    0x6D, 0x78, 0x3E, 0x1C, 0x2A, 0x46, 
                                    0x6E, 0x52, 0x3F, 0x06, 0x5B, 0x4F,
                                    0x66, 0x6D, 0x7D, 0x07, 0x7F, 0x6F,
                                    0x08};

        #region Font Buttons

        private byte A = 0x77;
        private byte B = 0x7C;
        private byte C = 0x39;
        private byte D = 0x5E;
        private byte E = 0x79;
        private byte F = 0x71;
        private byte G = 0x6F;
        private byte H = 0x76;
        private byte I = 0x30;
        private byte J = 0x1E;
        private byte K = 0x70;
        private byte L = 0x38;
        private byte M = 0x15;
        private byte N = 0x54;
        private byte O = 0x3F;
        private byte P = 0x73;
        private byte Q = 0x67;
        private byte R = 0x50;
        private byte S = 0x6D;
        private byte T = 0x78;
        private byte U = 0x3E;
        private byte V = 0x1C;
        private byte W = 0x2A;
        private byte X = 0x46;
        private byte Y = 0x6E;
        private byte Z = 0x52;
        private byte F0 = 0x3F;
        private byte F1 = 0x06;
        private byte F2 = 0x5B;
        private byte F3 = 0x4F;
        private byte F4 = 0x66;
        private byte F5 = 0x6D;
        private byte F6 = 0x7D;
        private byte F7 = 0x07;
        private byte F8 = 0x7F;
        private byte F9 = 0x6F;
        //private byte SP = 0x08; // show space as segment d
        //private byte vd = 0x00; // show no segments

        private void buttonFontA_Click(object sender, EventArgs e)
        {
            bitBangOutD(A);
        }

        private void buttonFontB_Click(object sender, EventArgs e)
        {
            bitBangOutD(B);
        }

        private void buttonFontC_Click(object sender, EventArgs e)
        {
            bitBangOutD(C);
        }

        private void buttonFontD_Click(object sender, EventArgs e)
        {
            bitBangOutD(D);
        }

        private void buttonFontE_Click(object sender, EventArgs e)
        {
            bitBangOutD(E);
        }

        private void buttonFontF_Click(object sender, EventArgs e)
        {
            bitBangOutD(F);
        }

        private void buttonFontG_Click(object sender, EventArgs e)
        {
            bitBangOutD(G);
        }

        private void buttonFontH_Click(object sender, EventArgs e)
        {
            bitBangOutD(H);
        }

        private void buttonFontI_Click(object sender, EventArgs e)
        {
            bitBangOutD(I);
        }

        private void buttonFontJ_Click(object sender, EventArgs e)
        {
            bitBangOutD(J);
        }

        private void buttonFontK_Click(object sender, EventArgs e)
        {
            bitBangOutD(K);
        }

        private void buttonFontL_Click(object sender, EventArgs e)
        {
            bitBangOutD(L);
        }

        private void buttonFontM_Click(object sender, EventArgs e)
        {
            bitBangOutD(M);
        }

        private void buttonFontN_Click(object sender, EventArgs e)
        {
            bitBangOutD(N);
        }

        private void buttonFontO_Click(object sender, EventArgs e)
        {
            bitBangOutD(O);
        }

        private void buttonFontP_Click(object sender, EventArgs e)
        {
            bitBangOutD(P);
        }

        private void buttonFontQ_Click(object sender, EventArgs e)
        {
            bitBangOutD(Q);
        }

        private void buttonFontR_Click(object sender, EventArgs e)
        {
            bitBangOutD(R);
        }

        private void buttonFontS_Click(object sender, EventArgs e)
        {
            bitBangOutD(S);
        }

        private void buttonFontT_Click(object sender, EventArgs e)
        {
            bitBangOutD(T);
        }

        private void buttonFontU_Click(object sender, EventArgs e)
        {
            bitBangOutD(U);
        }

        private void buttonFontV_Click(object sender, EventArgs e)
        {
            bitBangOutD(V);
        }

        private void buttonFontW_Click(object sender, EventArgs e)
        {
            bitBangOutD(W);
        }

        private void buttonFontX_Click(object sender, EventArgs e)
        {
            bitBangOutD(X);
        }

        private void buttonFontY_Click(object sender, EventArgs e)
        {
            bitBangOutD(Y);
        }

        private void buttonFontZ_Click(object sender, EventArgs e)
        {
            bitBangOutD(Z);
        }

        private void buttonFont0_Click(object sender, EventArgs e)
        {
            bitBangOutD(F0);
        }

        private void buttonFont1_Click(object sender, EventArgs e)
        {
            bitBangOutD(F1);
        }

        private void buttonFont2_Click(object sender, EventArgs e)
        {
            bitBangOutD(F2);
        }

        private void buttonFont3_Click(object sender, EventArgs e)
        {
            bitBangOutD(F3);
        }

        private void buttonFont4_Click(object sender, EventArgs e)
        {
            bitBangOutD(F4);
        }

        private void buttonFont5_Click(object sender, EventArgs e)
        {
            bitBangOutD(F5);
        }

        private void buttonFont6_Click(object sender, EventArgs e)
        {
            bitBangOutD(F6);
        }

        private void buttonFont7_Click(object sender, EventArgs e)
        {
            bitBangOutD(F7);
        }

        private void buttonFont8_Click(object sender, EventArgs e)
        {
            bitBangOutD(F8);
        }

        private void buttonFont9_Click(object sender, EventArgs e)
        {
            bitBangOutD(F9);
        }

        #endregion

        #region Tests

        private byte count = 0;
        private void timer1_Tick(object sender, EventArgs e)
        {
            bitBangOutD(font[count++]);
            if (count >= 36 ) count = 0;
        }

        private void buttonShowFont_Click(object sender, EventArgs e)
        {
            if (timer1.Enabled) { timer1.Enabled = false; buttonShowFont.Text = "Show Font"; }
            else { timer1.Enabled = true; buttonShowFont.Text = "Stop Font"; } 
        }

        int outCount = 0;
        byte[] outStr = new byte[128]; // 64 characters = 64 voids

        private bool hello = true;
        private void buttonHello_Click(object sender, EventArgs e)
        {
            if (hello)
            {
                hello = false;
                buttonHello.Text = "Stop Hello";
                sendtStringTo7SegOutput("Hello World");
            }
            else
            {
                timer2.Enabled = false;
                hello = true;
                buttonHello.Text = "Hello World";
            }
        }

        private bool sendTxt = true;
        private void buttonSendText_Click(object sender, EventArgs e)
        {
            if (sendTxt)
            {
                sendTxt = false;
                buttonSendText.Text = "Stop Text";
                sendtStringTo7SegOutput(textBoxSendText.Text);
            }
            else
            {
                timer2.Enabled = false;
                sendTxt = true;
                buttonSendText.Text = "Send Text";
            }
        }

        private void sendtStringTo7SegOutput(string str)
        {
            timer2.Enabled = false;
            timerCount = 0;
            outCount = 0;
            int temp = 0;
            foreach (byte s in outStr) outStr[temp++] = 0;

            // convert string to upper case
            str = str.ToUpper();

            // put it in an array
            char[] charStr = str.ToCharArray();

            byte b = 0;
            int strCount = 0;
            foreach (char c in charStr)
            {
                if (++outCount > 64)
                {
                    MessageBox.Show("Out string cannot have > 64 characters");
                    break;
                }

                b = Convert.ToByte(c);

                if (b == 32) // 32 is ASCII code for a space character
                {
                    outStr[strCount++] = 0x08; // substitute d segment for space character: 32
                    outStr[strCount++] = 0x00; // add a void to demark letters
                    outCount++; // increase count for added voids
                }
                else
                {    
                    if ( (b > 64) && (b < 91))//filter for capital letters only
                    {
                        b -= 65; // it is a character
                        outStr[strCount++] += font[b];
                        outStr[strCount++] = 0x00; // add a void to demark letters
                        outCount++; // increase count for added voids
                    }
                    else if ((b > 47) && (b < 58)) // filter for numerals
                    {
                        b -= (48 - 26); // it is a number - numbers start a 26 in font array
                        outStr[strCount++] += font[b];
                        outStr[strCount++] = 0x00; // add a void to demark letters
                        outCount++; // increase count for added voids
                    }
                }
            }
            timer2.Enabled = true;
        }

        int timerCount = 0;
        private void timer2_Tick(object sender, EventArgs e)
        {
            bitBangOutD(outStr[timerCount++]);
            if(timerCount > outCount) timerCount = 0;
        }

        private void buttonstopText_Click(object sender, EventArgs e)
        {
            int temp = 0;
            foreach( byte b in outStr) outStr[temp++] = 0;
            timer2.Enabled = false;
        }

        #endregion
    }
}