Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Text
Imports System.Windows.Forms

Imports SMD2XX

Namespace SelectDevice

	' 1 opens by serial number using FT_OpenEX
	' 2 opens by description using FT_OpenEX
	' 3 opens by Location Id using FT_OpenEX
	' 4 opens by device number using FT_Open
    Public Enum OPEN_BY
        SERIAL_NUMBER = 1
        DESCRIPTION
        LOCATIONID
        DEVICE_NUMBER
    End Enum

	Public Partial Class Select_Device
		Inherits Form
		Private ftStatus As FT_STATUS ' create an instance the FT_STATUS enum

		Private SM As SM_D2XX = New SM_D2XX()

		Public Sub New()
			InitializeComponent()
		End Sub

		Private Sub SelectAndOpenDevice_Load_1(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
			ftStatus = SM.createDeviceInfoList()
			If ftStatus <> FT_STATUS.FT_OK Then
				MessageBox.Show("Error: buttonGet_Click FT_CreateDeviceInfoList failed.")
				Return
			End If

			comboBoxSerialNumber.Items.Clear()
			comboBoxDescription.Items.Clear()
			comboBoxLocID.Items.Clear()


			richTextBox1.Text = "Numer of devices = " & SM.NumDevs.ToString() & Constants.vbLf

			For n As UInt32 = 0 To SM.NumDevs - 1
				SM.getDeviceInfoDetail(n)

				serialNumber_p = SM.SerialNumber
				description_p = SM.Description
				locID_p = SM.LocID

				If ftStatus <> FT_STATUS.FT_OK Then
					MessageBox.Show("Error: GetDeviceInfoDetail failed.")
					Return
				Else
					comboBoxSerialNumber.Items.Add(serialNumber_p)
					comboBoxDescription.Items.Add(description_p)
					comboBoxLocID.Items.Add(locID_p)
					richTextBox1.Text += Constants.vbLf & "SerialNumber = " & serialNumber_p
					richTextBox1.Text += Constants.vbLf & "Description = " & description_p
					richTextBox1.Text += Constants.vbLf & "LocID = " & locID_p.ToString() & Constants.vbLf
				End If
			Next n
		End Sub


		#Region "Properties"

		Private serialNumber_p As String = "NOT INITIALIZED"
		Public Property SerialNumber() As String
			Get
				Return serialNumber_p
			End Get
			Set(ByVal value As String)
				serialNumber_p = value
			End Set
		End Property

		Private description_p As String = "NOT INITIALIZED"
		Public Property Description() As String
			Get
				Return description_p
			End Get
			Set(ByVal value As String)
				description_p = value
			End Set
		End Property

		Private locID_p As UInt32
		Public Property LocID() As UInt32
			Get
				Return locID_p
			End Get
			Set(ByVal value As UInt32)
				locID_p = value
			End Set
		End Property

		Private index_p As UInt32
		Public Property Index() As UInt32
			Get
				Return index_p
			End Get
			Set(ByVal value As UInt32)
				index_p = value
			End Set
		End Property

		Private openBy_p As UInt32
		Public Property OpenBy() As UInt32
			Get
				Return openBy_p
			End Get
			Set(ByVal value As UInt32)
				openBy_p = value
			End Set
		End Property

		#End Region

		#Region "Select Device to Open"
		Private Sub comboBoxSerialNumber_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs) Handles comboBoxSerialNumber.SelectedIndexChanged
            openBy_p = CUInt(OPEN_BY.SERIAL_NUMBER)
			serialNumber_p = comboBoxSerialNumber.SelectedItem.ToString()
			index_p = CUInt(comboBoxSerialNumber.SelectedIndex)
			Close()
		End Sub

		Private Sub comboBoxDescription_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs) Handles comboBoxDescription.SelectedIndexChanged
            openBy_p = CUInt(OPEN_BY.DESCRIPTION)
			description_p = comboBoxDescription.SelectedItem.ToString()
			index_p = CUInt(comboBoxDescription.SelectedIndex)
			Close()
		End Sub

		Private Sub comboBoxLocID_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs) Handles comboBoxLocID.SelectedIndexChanged
            openBy_p = CUInt(OPEN_BY.LOCATIONID)
			locID_p = UInt32.Parse(comboBoxLocID.SelectedItem.ToString())
			index_p = CUInt(comboBoxLocID.SelectedIndex)
			Close()
		End Sub
		#End Region


	End Class
End Namespace